using System;
using System.Xml;
using System.Xml.Schema;

class XMLValidationDemo
{
	private static bool mValid;

	static void Main()
	{
		XmlTextReader tr = new XmlTextReader(
			"../../../xml-files/library-valid.xml");

//			"../../../xml-files/library-invalid.xml");

		XmlValidatingReader vr = new XmlValidatingReader(tr);

		vr.Schemas.Add("http://www.nakov.com/schemas/library", 
			"../../../xml-files/library.xsd");
		vr.ValidationType = ValidationType.Schema;
		vr.ValidationEventHandler += 
			new ValidationEventHandler(ValidationHandler);

		mValid = true;
		while(vr.Read())
		{
			// Do nothing, just read whole the document.
		}

		if (mValid)
		{
			Console.WriteLine("The document is valid.");
		}
	}

	public static void ValidationHandler(object sender, 
		ValidationEventArgs args)
	{
		mValid = false;
		Console.WriteLine("***Validation error");
		Console.WriteLine("\tSeverity:{0}", args.Severity);
		Console.WriteLine("\tMessage:{0}", args.Message);
	}
}